/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <config.h>

#include <gtk/gtk.h>

#include "help.h"

void 
show_help (BonoboUIComponent *uic,
	   MCData            *mcdata,
	   const char        *verbname)
{
    GError *error = NULL;
    gchar *help_uri;
   
/*    gnome_help_display_on_screen (
		"rcalc-applet", NULL,
		gtk_widget_get_screen (GTK_WIDGET (mcdata->applet)),
		&error);*/

/* gnome_help_display_with_doc_id (NULL,
                                             PACKAGE,
                                             "rcalc-applet",
                                             NULL,
                                             &error);*/
    
    help_uri = g_strdup_printf("ghelp:%s/rcalc-applet.xml", PACKAGE);
    gnome_help_display_uri (help_uri, &error);
    g_free(help_uri);
    if (error)
    {
							GtkWidget * errmsg;
							g_warning ("help error: %s\n", error->message);

							errmsg = gtk_message_dialog_new (NULL,
															 GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
															 GTK_MESSAGE_WARNING,
															 GTK_BUTTONS_CLOSE,
															 error->message);
									
							gtk_dialog_run (GTK_DIALOG (errmsg));
							
							g_error_free (error);
              error = NULL;
							gtk_widget_destroy (errmsg);
		}
            
}
